@version 2.0
@warnings
@script generic
/*
Written by faulknermano, Lernwel D Ang.
This LScript is offered uncompiled and may be modified for your learning experience.
*/

var loop = 1;
var koffset = 0;


generic
{
	scene=getfirstitem(SCENE);
	selected = scene.firstSelect();
	if(selected == nil)
		return;
	for(o=1;selected;++o)
	{
		sName[o] = selected.name;
		sID[o] = selected.id;
		selected = scene.nextSelect();
	}

	return if(!reqbegin("Motion Cycle"));
	a0 = ctlinteger("Number of Loops/Repeats",loop);
	a1 = ctlinteger("Keyframe Offset *Optional*",koffset);
	return if(!reqpost());
	loop = getvalue(a0);
	koffset = getvalue(a1);
	reqend();

	motdir = getdir("Motions");

	for(f=1;f<o;++f)
	{
		SelectItem(sID[f]);
		origmotfile = string(motdir,"motion_cycle_src.mot");
		newmotfile = string(motdir,"motion_cycle_tgt.mot");
		SaveMotion(origmotfile);

		parsefile = File(origmotfile,"r");
		if(parsefile == nil)
		{
			error("Unable to access Original Motion File.");
			return;
		}
		outputfile = File(newmotfile,"w");
		if(outputfile == nil)
		{
			error("Unable to create Output Motion File.");
			return;
		}

		outputfile.writeln("LWMO");
		for(r=1;!parsefile.eof();++r)
		{
			(data,value) = parse(" ",parsefile.read(r));
			if(data == LWMO)
				outputfile.writeln(data);
			if(data == 3)
				outputfile.writeln(data);
			if(data == "")
				outputfile.nl();
			if(data == "NumChannels")
				outputfile.writeln(data," ",value);

			if(data == "Channel")
			{
				value = number(value);
				outputfile.writeln("Channel ",value);
				outputfile.writeln("{ Envelope");
				r = r + 2;
				keycount = integer(parsefile.read(r));
				if(keycount<=1)
					break;
				(trash,val1,ti1) = parse(" ",parsefile.read(r+1+koffset));
				(trash,val2,ti2) = parse(" ",parsefile.read(r+keycount));

				val1 = number(val1);
				val2 = number(val2);
				ti1 = number(ti1);
				ti2 = number(ti2);

				valofst = val2 - val1;
				tiofst = ti2 - ti1;

				outputfile.writeln("  ",(((keycount)-(1))  * loop) + ((keycount) - (koffset)));
	
				for(k=1;k<=keycount;++k)
				{
					(trash,val,ti,ic,t,c,b) = parse(" ",parsefile.read(r+k));
					outputfile.writeln("  ","Key ",val," ",ti," ",ic," ",t," ",c," ",b," 0 0 0");
				}
				for(j=1;j<=loop;++j)
				{
					for(m=koffset+2;m<=keycount;++m)
					{
						(trash,val,ti,ic,t,c,b) = parse(" ",parsefile.read(r+m));
						val = number(val);
						ti = number(ti);
						ic = number(ic);
						t = number(t);
						c = number(c);
						b = number(b);
						valb = val + (valofst * j);
						tib = ti + (tiofst * j);
						outputfile.writeln("  ","Key ",valb," ",tib," ",ic," ",t," ",c," ",b," 0 0 0");
					}					
				}
				(data,value1,value2) = parse(" ",parsefile.read(r + keycount + 1));
				outputfile.writeln("  Behaviors ",value1," ",value2);
				outputfile.writeln("}");
			}
		LoadMotion(newmotfile);
		}
	}
}

